LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
ENTITY Bjsk_tester IS
-- Generic parameters
GENERIC (n      :INTEGER := 3); -- Number of players
PORT(
        Clk             :OUT STD_LOGIC;  -- Global Clk
        Reset           :OUT STD_LOGIC;  -- Global Reset
-- from Card Generator 
        Card            :OUT STD_LOGIC_VECTOR (3 downto 0); -- Card Value

-- form controller
		PlayerId        :OUT STD_LOGIC_VECTOR (n-1 downto 0);
		cgIssue         : OUT STD_LOGIC; -- Card has been issued
	--	cgNewHand       : OUT STD_LOGIC; -- New hand
		PlStand         : OUT STD_LOGIC; --All player stand
--from banker
		GameOver        : OUT STD_LOGIC;  
--Outputs      
        Action          :IN STD_LOGIC_VECTOR (2*n-3 downto 0);-- Output to the Banker
	TakeAction      : IN STD_LOGIC   
--Temp outputs
--	HPTotal          : IN STD_LOGIC_VECTOR (4 downto 0)  ;
--	Card1		: IN STD_LOGIC_VECTOR (4 DOWNTO 0)
        
);
END Bjsk_tester;

ARCHITECTURE test OF Bjsk_tester IS
-- General Out-- Architecture declarations
CONSTANT clk_prd : time := 100 ns;
SIGNAL iclk : std_logic;

PROCEDURE wait_clock(CONSTANT clk_ticks:integer) IS
VARIABLE i : integer := 0;
BEGIN
   FOR i IN 0 TO clk_ticks LOOP
      WAIT UNTIL rising_edge(iclk);
   END LOOP;
END wait_clock;

BEGIN
Main :Process

BEGIN
       --Initialization
        Reset <= '0';
	--cgIssue <= '0' ;
--	cgNewHand <= '0';
	PlayerId <= (OTHERS => '0');
	GameOver <= '0';
	Card <= "0000";
	wait_clock(10);
	Reset <= '1';
	wait_clock(10);
	wait_clock(10);
	Reset <= '0';
	
	wait_clock(10);
--first card first player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="001";
	wait_clock(10);
	Card<="1010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--first card second player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="010";
	wait_clock(10);
	Card<="0010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--first card third player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="100";
	wait_clock(10);
	Card<="0100";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--second card first player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="001";
	wait_clock(10);
	Card<="0110";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--second card second player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="010";
	wait_clock(10);
	Card<="1010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--second card third player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="100";
	wait_clock(10);
	Card<="0101";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--third card first player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="001";
	wait_clock(10);
	Card<="0101";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--third card second player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="010";
	wait_clock(10);
	Card<="1010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--third card third player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="100";
	wait_clock(10);
	Card<="0010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(2);
	cgIssue<='0';
	wait_clock(2);
	PlStand <= '1';
	wait_clock(5);
	PlStand <='0';
--New hand starts here	

--first card first player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="001";
	wait_clock(10);
	Card<="1010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--first card second player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="010";
	wait_clock(10);
	Card<="0010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--first card third player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="100";
	wait_clock(10);
	Card<="0100";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--second card first player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="001";
	wait_clock(10);
	Card<="0001";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--second card second player	
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="010";
	wait_clock(10);
	Card<="1010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--second card third player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="100";
	wait_clock(10);
	Card<="0101";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--third card first player
	cgIssue<='0';

	
--third card second player
	wait_clock(20);
	PlayerId<="010";
	wait_clock(10);
	Card<="1010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(10);
--third card third player
	cgIssue<='0';
	wait_clock(20);
	PlayerId<="100";
	wait_clock(10);
	Card<="0010";
	wait_clock(10);
	cgIssue<='1';
	wait_clock(2);
	cgIssue<='0';
	wait_clock(2);
	PlStand <= '1';
	wait_clock(5);	
        PlStand <= '0';	

end process main;
-- Architecture concurrent statements
-- Clock generator
ClockGen : PROCESS
BEGIN
   iclk <= '0';
   WAIT FOR clk_prd/2;
   iclk <= '1';
   WAIT FOR clk_prd/2;
END PROCESS ClockGen;
clk <= iclk;

END test;
	

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.all;
ENTITY Bjsk_testbench IS
-- Test bench has no external interface
GENERIC (n      :INTEGER := 3); -- Number of players
END Bjsk_testbench ;
ARCHITECTURE struct OF Bjsk_testbench IS
signal Clk             : STD_LOGIC;  -- Global Clk
signal Reset           : STD_LOGIC;  -- Global Reset 
signal Card            : STD_LOGIC_VECTOR (3 downto 0); -- Card Value
signal PlayerId        :STD_LOGIC_VECTOR (n-1 downto 0);
signal cgIssue         : STD_LOGIC; -- Card has been issued
--signal cgNewHand       : STD_LOGIC; -- New hand
signal GameOver        : STD_LOGIC;        
signal Action          : STD_LOGIC_VECTOR (2*n-3 downto 0);-- Output to the Banker
--signal HPTotal         : STD_LOGIC_VECTOR (4 downto 0);
--SIGNAL	Card1		: STD_LOGIC_VECTOR (4 DOWNTO 0);
signal PlStand         : STD_LOGIC;
signal	TakeAction      : STD_LOGIC   ;
COMPONENT Bjsk
PORT ( Clk             :IN STD_LOGIC;  -- Global Clk
        Reset           :IN STD_LOGIC;  -- Global Reset 
        Card            :IN STD_LOGIC_VECTOR (3 downto 0); -- Card Value
	PlayerId        :IN STD_LOGIC_VECTOR (n-1 downto 0);
	cgIssue         : IN STD_LOGIC; -- Card has been issued
--	cgNewHand       : IN STD_LOGIC; -- New hand
	PlStand         : IN STD_LOGIC;
	GameOver        : IN STD_LOGIC;
        Action          :OUT STD_LOGIC_VECTOR (2*n-3 downto 0);-- Output to the Banker
--	HPTotal         :OUT STD_LOGIC_VECTOR (4 downto 0);
--	Card1		: OUT STD_LOGIC_VECTOR (4 DOWNTO 0);
	TakeAction      : OUT STD_LOGIC   

);
END COMPONENT;

COMPONENT Bjsk_tester
PORT (
        Clk             :OUT STD_LOGIC;  -- Global Clk
        Reset           :OUT STD_LOGIC;  -- Global Reset
        Card            :OUT STD_LOGIC_VECTOR (3 downto 0); -- Card Value
	PlayerId        :OUT STD_LOGIC_VECTOR (n-1 downto 0);
	cgIssue         : OUT STD_LOGIC; -- Card has been issued
--	cgNewHand       : OUT STD_LOGIC; -- New hand
	PlStand         : OUT STD_LOGIC ;
	GameOver        : OUT STD_LOGIC;  
        Action          :IN STD_LOGIC_VECTOR (2*n-3 downto 0);-- Output to the Banker
--	 HPTotal         : IN STD_LOGIC_VECTOR (4 downto 0);
-- 	Card1		: IN STD_LOGIC_VECTOR (4 DOWNTO 0);
	TakeAction      : IN STD_LOGIC   
       
);
END COMPONENT;
BEGIN
UUT: Bjsk 
     PORT MAP (
    	Clk=>Clk,
	Reset => Reset,
	cgIssue => cgIssue,
	--cgNewHand => cgNewHand,
	PlayerId => PlayerId,
	GameOver => GameOver,
	Action => Action,
--	HPTotal => HPTotal,
	Card => Card,
--	Card1 => Card1,
	PlStand => PlStand,
	TakeAction => TakeAction
);
Checker: Bjsk_tester
	PORT MAP (
	Clk=>Clk,
	Reset => Reset,
	cgIssue => cgIssue,
	--cgNewHand => cgNewHand,
	PlStand  => PlStand,
	PlayerId => PlayerId,
	GameOver => GameOver,
	Action => Action,
--	HPTotal => HPTotal,
	Card => Card,
--	Card1 => Card1,
	TakeAction => TakeAction
);
END struct;
